# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           scalate
Version:        1.4.1
Release:        2%{?dist}
Epoch:          0
Summary:        Scalate Template Engine
License:        Apache Software License 2.0
Group:          Development/Java
URL:            http://scalate.fusesource.org/
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch
Source0:        scalate-1.4.1.tgz
# git clone git://github.com/scalate/scalate.git
# cd scalate
# git-tag -l
# mkdir ../scalate-1.4.1
# git archive scalate-project-1.4.1 | tar -x -C ../scalate-1.4.1
# cd ..
# tar czf scalate-1.4.1.tgz scalate-1.4.1/

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        jackrabbit-parent-5.pom

Patch0:         scalate-pom.patch
Patch1:         scalate-bootstrap-pom.patch
Patch2:         scalate-maven-scalate-plugin-pom.patch
Patch3:         scalate-samples-scalate-sample-pom.patch
Patch4:         scalate-markdownj-pom.patch
Patch5:         scalate-tool-Run.patch
Patch6:         scalate-tool-Create.patch
Patch7:         scalate-tool-Exit.patch
Patch8:         scalate-tool-ToScaml.patch
Patch9:         scalate-tool-ScalateMain.patch
Patch10:        scalate-jsp-converter-JspConvert.patch

BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-changes
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-war
BuildRequires:  fusesource-mvnplugins
BuildRequires:  mojo-exec-maven-plugin
BuildRequires:  maven-scala-plugin
BuildRequires:  maven-script-interpreter
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-skins
BuildRequires:  maven-archetype2
BuildRequires:  aries-testsupport
BuildRequires:  james-project
BuildRequires:  jetty6-maven2-plugins
BuildRequires:  google-pom
BuildRequires:  oss-parent

BuildRequires:  apache-mime4j
BuildRequires:  geronimo-servlet-2.5-api
BuildRequires:  htmlunit2
BuildRequires:  jersey
BuildRequires:  karaf
BuildRequires:  logback
BuildRequires:  markdownj
BuildRequires:  org.osgi.core
BuildRequires:  scala28
BuildRequires:  scalamd
BuildRequires:  scalatest
BuildRequires:  selenium
BuildRequires:  slf4j
BuildRequires:  snakeyaml
BuildRequires:  spring3-web-servlet
BuildRequires:  wikitext

Requires:  java >= 0:1.6.0
Requires:  jersey
Requires:  karaf
Requires:  logback
Requires:  markdownj
Requires:  org.osgi.core
Requires:  scala28
Requires:  scalamd
Requires:  selenium
Requires:  slf4j
Requires:  snakeyaml
Requires:  spring3-web-servlet
Requires:  wikitext

%description
Scalate is a Scala 2.8 based template engine for generating
text and markup which can be used in the following 
frameworks and environments:
* stand alone in any JVM or as a Servlet Filter in any Java
  in a web application
* with JAXRS with Jersey
* in the Play Framework via play-scalate
* in Apache Camel for transforming messages and templating
* to generate your static or semi-static website
Scalate supports the following template formats
* Mustache which is a Scala dialect of Mustache for 
  logic-less templates which also work inside the browser 
  using mustache.js
* Scaml which is a Scala dialect of Haml and is very DRY for
  generating HTML / XHTML
* Jade which is an even more DRY dialect of Scaml for HTML /
  XHTML markup generation
* SSP which is like Velocity, JSP or Erb from Rails
Scalate also has a powerful web console and command line 
shell which includes converters from JSP or HTML to Scalate.

%prep
%setup -q 
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4
%patch5 -b .sav5
%patch6 -b .sav6
%patch7 -b .sav7
%patch8 -b .sav8
%patch9 -b .sav9
%patch10 -b .sav10

cp -p %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

for p in $(find . -name pom.xml); do
    sed -i -e "s|jetty-maven-plugin|maven-jetty-plugin|" $p
done

rm maven-scalate-plugin/src/main/java/org/fusesource/scalate/maven/ConfExportMojo.scala
rm scalate-tool/src/main/scala/org/fusesource/scalate/tool/commands/ConfluenceExport.scala

%build
export CLASSPATH=
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}/
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/jackrabbit/parent/5/
cp %{SOURCE3} ${MAVEN_REPO_LOCAL}/org/apache/jackrabbit/parent/5/parent-5.pom

export MAVEN_SETTINGS=$(pwd)/settings.xml
export MAVEN_OPTS="-Xmx512m -XX:MaxPermSize=128m"
%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven.test.failure.ignore=true \
        install 

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-project.pom
%add_to_maven_depmap org.fusesource.scalate scalate-project %{version} JPP/%{name} project
install -m 644 archetypes/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-archetypes.pom
%add_to_maven_depmap org.fusesource.scalate.tooling archetypes %{version} JPP/%{name} archetypes
install -m 644 archetypes/scalate-archetype-guice/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-archetype-guice.pom
%add_to_maven_depmap org.fusesource.scalate.tooling scalate-archetype-guice %{version} JPP/%{name} archetype-guice
install -m 0644 archetypes/scalate-archetype-guice/target/scalate-archetype-guice-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/archetype-guice-%{version}.jar
install -m 644 archetypes/scalate-archetype-jersey/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-archetype-jersey.pom
%add_to_maven_depmap org.fusesource.scalate.tooling scalate-archetype-jersey %{version} JPP/%{name} archetype-jersey
install -m 0644 archetypes/scalate-archetype-jersey/target/scalate-archetype-jersey-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/archetype-jersey-%{version}.jar
install -m 644 archetypes/scalate-archetype-sitegen/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-archetype-sitegen.pom
%add_to_maven_depmap org.fusesource.scalate.tooling scalate-archetype-sitegen %{version} JPP/%{name} archetype-sitegen
install -m 0644 archetypes/scalate-archetype-sitegen/target/scalate-archetype-sitegen-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/archetype-sitegen-%{version}.jar
install -m 644 maven-scalate-plugin/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-maven-scalate-plugin.pom
%add_to_maven_depmap org.fusesource.scalate maven-scalate-plugin %{version} JPP/%{name} maven-scalate-plugin
install -m 0644 maven-scalate-plugin/target/maven-scalate-plugin-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/maven-scalate-plugin-%{version}.jar
install -m 644 samples/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-samples.pom
%add_to_maven_depmap org.fusesource.scalate.samples samples %{version} JPP/%{name} samples
install -m 644 samples/scalate-bookstore/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-scalate-bookstore.pom
%add_to_maven_depmap org.fusesource.scalate.samples scalate-bookstore %{version} JPP/%{name} scalate-bookstore
#install -m 0644 samples/scalate-bookstore/target/scalate-bookstore-%{version}-sources.jar \
#    $RPM_BUILD_ROOT%{_javadir}/%{name}/sources/scalate-bookstore-sources-%{version}.jar
install -m 0644 samples/scalate-bookstore/target/scalate-bookstore-%{version}.war $RPM_BUILD_ROOT%{_datadir}/%{name}/
install -m 644 samples/scalate-sample-scuery/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-scalate-sample-scuery.pom
%add_to_maven_depmap org.fusesource.scalate.samples scalate-sample-scuery %{version} JPP/%{name} scalate-sample-scuery
#install -m 0644 samples/scalate-sample-scuery/target/scalate-sample-scuery-%{version}-sources.jar \
#    $RPM_BUILD_ROOT%{_javadir}/%{name}/sources/scalate-sample-scuery-sources-%{version}.jar
install -m 0644 samples/scalate-sample-scuery/target/scalate-sample-scuery-%{version}.war $RPM_BUILD_ROOT%{_datadir}/%{name}/
install -m 644 samples/scalate-sample-sitegen/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-scalate-sample-sitegen.pom
%add_to_maven_depmap org.fusesource.scalate.samples scalate-sample-sitegen %{version} JPP/%{name} scalate-sample-sitegen
#install -m 0644 samples/scalate-sample-sitegen/target/scalate-sample-sitegen-%{version}-sources.jar \
#    $RPM_BUILD_ROOT%{_javadir}/%{name}/sources/scalate-sample-sitegen-sources-%{version}.jar
install -m 0644 samples/scalate-sample-sitegen/target/scalate-sample-sitegen-%{version}.war $RPM_BUILD_ROOT%{_datadir}/%{name}/
install -m 644 samples/scalate-sample-spring-mvc/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-scalate-sample-spring-mvc.pom
%add_to_maven_depmap org.fusesource.scalate.samples scalate-sample-spring-mvc %{version} JPP/%{name} scalate-sample-spring-mvc
install -m 0644 samples/scalate-sample-spring-mvc/target/scalate-sample-spring-mvc-%{version}.war $RPM_BUILD_ROOT%{_datadir}/%{name}/
install -m 644 samples/scalate-sample/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-scalate-sample.pom
%add_to_maven_depmap org.fusesource.scalate.samples scalate-sample %{version} JPP/%{name} scalate-sample
#install -m 0644 samples/scalate-sample/target/scalate-sample-%{version}-sources.jar \
#    $RPM_BUILD_ROOT%{_javadir}/%{name}/sources/scalate-sample-sources-%{version}.jar
install -m 0644 samples/scalate-sample/target/scalate-sample-%{version}.war $RPM_BUILD_ROOT%{_datadir}/%{name}/
# Don't forget BUILD/scalate-1.4.1/scalate-camel/pom.xml
install -m 644 scalate-core/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-core.pom
%add_to_maven_depmap org.fusesource.scalate scalate-core %{version} JPP/%{name} core
install -m 0644 scalate-core/target/scalate-core-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 scalate-guice/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-guice.pom
%add_to_maven_depmap org.fusesource.scalate scalate-guice %{version} JPP/%{name} guice
install -m 0644 scalate-guice/target/scalate-guice-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/guice-%{version}.jar
install -m 644 scalate-jsp-converter/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jsp-converter.pom
%add_to_maven_depmap org.fusesource.scalate scalate-jsp-converter %{version} JPP/%{name} jsp-converter
install -m 0644 scalate-jsp-converter/target/scalate-jsp-converter-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/jsp-converter-%{version}.jar
install -m 644 scalate-markdownj/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-markdownj.pom
%add_to_maven_depmap org.fusesource.scalate scalate-markdownj %{version} JPP/%{name} markdownj
install -m 0644 scalate-markdownj/target/scalate-markdownj-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/markdownj-%{version}.jar
install -m 644 scalate-page/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-page.pom
%add_to_maven_depmap org.fusesource.scalate scalate-page %{version} JPP/%{name} page
install -m 0644 scalate-page/target/scalate-page-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/page-%{version}.jar
install -m 644 scalate-spring-mvc/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-spring-mvc.pom
%add_to_maven_depmap org.fusesource.scalate scalate-spring-mvc %{version} JPP/%{name} spring-mvc
install -m 0644 scalate-spring-mvc/target/scalate-spring-mvc-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/spring-mvc-%{version}.jar
install -m 644 scalate-test/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-test.pom
%add_to_maven_depmap org.fusesource.scalate scalate-test %{version} JPP/%{name} test
install -m 0644 scalate-test/target/scalate-test-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/test-%{version}.jar
install -m 644 scalate-tool/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-tool.pom
%add_to_maven_depmap org.fusesource.scalate scalate-tool %{version} JPP/%{name} tool
install -m 0644 scalate-tool/target/scalate-tool-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/tool-%{version}.jar
install -m 644 scalate-util/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-util.pom
%add_to_maven_depmap org.fusesource.scalate scalate-util %{version} JPP/%{name} util
install -m 0644 scalate-util/target/scalate-util-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/util-%{version}.jar
install -m 644 scalate-war/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-war.pom
%add_to_maven_depmap org.fusesource.scalate scalate-war %{version} JPP/%{name} scalate-war
install -m 0644 scalate-war/target/scalate-war-%{version}.war $RPM_BUILD_ROOT%{_datadir}/%{name}/
#BUILD/scalate-1.4.1/scalate-web/pom.xml
#BUILD/scalate-1.4.1/scalate-website/pom.xml
install -m 644 scalate-wikitext/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-wikitext.pom
%add_to_maven_depmap org.fusesource.scalate scalate-wikitext %{version} JPP/%{name} wikitext
install -m 0644 scalate-wikitext/target/scalate-wikitext-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/wikitext-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name}
for jar in *-%{version}*.jar; do ln -sf ${jar} `echo ${jar} | sed "s|-%{version}||g"`;done)

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp license.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp *.md $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_docdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/%{name}
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%dir %{_docdir}/%{name}-%{version}
%{_docdir}/%{name}-%{version}/*
%dir %{_docdir}/%{name}

%changelog
* Tue Feb 05 2013 Ralph Apel <r.apel@r-apel.de> 0:1.4.1-2
- Prevent xzpayload problem

* Thu Jan 17 2013 Ralph Apel <r.apel@r-apel.de> 0:1.4.1-1
- first release

